/**
 * @file
 * TriggerApiCKeditorPlugin CKEditor plugin.
 *
 * Basic plugin inserting abbreviation elements into the CKEditor editing area.
 *
 * @DCG The code is based on an example from CKEditor Plugin SDK tutorial.
 *
 * @see http://docs.ckeditor.com/#!/guide/plugin_sdk_sample_1
 */

(function (Drupal) {

  'use strict';

  CKEDITOR.plugins.add('trigger_api_ckeditor_plugin', {

    // Register the icons.
    icons: 'trigger-api-plugin',

    // The plugin initialization logic goes inside this method.
    init: function (editor) {

      // Add custom command.
      // @todo
      // editor.addCommand('triggerApiPlugin', {
      //   allowedContent:
      //     'a',
      //   modes: { wysiwyg: 1 },
      //   canUndo: true,
      //   exec(editor, data) {
      //     const dialogSettings = {
      //       title: data.dialogTitle,
      //       dialogClass: 'editor-image-dialog',
      //     };
      //     Drupal.ckeditor.openDialog(
      //       editor,
      //       Drupal.url("/trigger-api/trigger-api-ckeditor"),
      //       data.existingValues,
      //       data.saveCallback,
      //       dialogSettings,
      //     );
      //   },
      // });

      // Create a toolbar button that executes the above command.
      editor.ui.addButton('trigger-api-plugin', {

        // The text part of the button (if available) and the tooltip.
        label: Drupal.t('Insert Trigger API data'),

        // The command to execute on click.
        command: 'triggerApiPlugin',

        // The button placement in the toolbar (toolbar group name).
        toolbar: 'insert'
      });

    }
  });

} (Drupal));
