<?php

namespace Drupal\trigger_api\Plugin\CKEditorPlugin;

use Drupal\ckeditor\CKEditorPluginBase;
use Drupal\editor\Entity\Editor;

/**
 * Defines the "TriggerApiCKEditorPlugin" plugin.
 *
 * @CKEditorPlugin(
 *   id = "trigger_api_ckeditor_plugin",
 *   label = @Translation("Trigger API - CKEditor"),
 *   module = "trigger_api"
 * )
 */
class TriggerApiCKEditorPlugin extends CKEditorPluginBase {

  /**
   * {@inheritdoc}
   */
  public function getFile() {
    return drupal_get_path('module', 'trigger_api') . '/js/plugins/ckeditor-plugin/plugin.js';
  }

  /**
   * {@inheritdoc}
   */
  public function getConfig(Editor $editor) {
    return [];
  }

  /**
   * {@inheritdoc}
   */
  public function getButtons() {
    $module_path = drupal_get_path('module', 'trigger_api');
    return [
      'ckeditor-plugin' => [
        'label' => $this->t('TriggerApiCKeditorPlugin'),
        'image' => $module_path . '/js/plugins/ckeditor-plugin/icons/ckeditor-plugin.png',
      ],
    ];
  }

}
